#!/usr/bin/perl -w

use strict;




##############################################
##Reading parameters
##############################################

my $c=0;
my %parameters=();

while ((exists $ARGV[$c])&&(exists $ARGV[($c+1)])){
  $parameters{$ARGV[$c]}=$ARGV[($c+1)];
  $c=$c+2;
}

my $file=$parameters{"-file"};

my %metricVal=();
my %systems=();
my %topics=();
my %measures=();

open (FICH,$file) or die;  
while (my $line=<FICH>){
  chop $line;
  if ($line=~/\S/){
    (my $system, my $topic, my $metric,my $val)=split(/\t/,$line);
    $metricVal{$system}{$topic}{$metric}=$val; 
    $systems{$system}=1;
    $topics{$topic}=1;
    $measures{$metric}=1;
  }
}


our $numTopics=0;
foreach my $topic (keys %topics){
  $numTopics++;
}




my %UIR=();
foreach my $system1 (keys %systems){
  foreach my $system2 (keys %systems){
    my $imp1=0;
    my $imp2=0;
    foreach my $topic (keys %topics){
      my $condition=1;
      foreach my  $metric (keys %measures){	  
	if (!(exists $metricVal{$system1}{$topic}{$metric})){
	  print "Error: value for the measure $metric in $system1 and topic $topic is not provided\n";
	}
	if (!(exists $metricVal{$system2}{$topic}{$metric})){
	  print "Error: value for the measure $metric in $system2 and topic $topic is not provided\n";
	}

	if ($metricVal{$system1}{$topic}{$metric}<
	    $metricVal{$system2}{$topic}{$metric}){
	  $condition=0;
	}
      }
      if ($condition==1){
	$imp1++;
      }  
      $condition=1;
      foreach my $metric (keys %measures){
	if ($metricVal{$system2}{$topic}{$metric}<
	    $metricVal{$system1}{$topic}{$metric}){
	  $condition=0;
	}
      }
      if ($condition==1){
	$imp2++;
	
      }
    }
    $UIR{$system1}{$system2}=($imp1-$imp2)/($numTopics);
    print "$system1\t$system2\t$UIR{$system1}{$system2}\t$imp1\t$imp2\n";
  }
}



if (exists $parameters{"-thresholdNonImp"}){
  
  foreach my $system1 (keys %systems){
    print "\n$system1 is improved by:\t";
      foreach my $system2 (keys %systems){
	if ($UIR{$system2}{$system1}>=$parameters{"-thresholdNonImp"}){
	  print "$system2\t";
	}
      }
  }
}



if (exists $parameters{"-thresholdImp"}){
  
  foreach my $system1 (keys %systems){
    print "\n$system1 improves:\t";
      foreach my $system2 (keys %systems){
	if ($UIR{$system1}{$system2}>=$parameters{"-thresholdImp"}){
	  print "$system2\t";
	}
      }
  }
}













